diff --git a/drivers/baseband/meson.build b/drivers/baseband/meson.build
index 920e3b02e..c98ebd902 100644
--- a/drivers/baseband/meson.build
+++ b/drivers/baseband/meson.build
@@ -2,7 +2,13 @@
 # Copyright(c) 2018 Luca Boccassi <bluca@debian.org>
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['null', 'turbo_sw', 'fpga_lte_fec', 'fpga_5gnr_fec', 'acc100']
+drivers = [
+        'acc100',
+        'fpga_5gnr_fec',
+        'fpga_lte_fec',
+        'null',
+        'turbo_sw',
+]
diff --git a/drivers/bus/meson.build b/drivers/bus/meson.build
index 2e7727af0..c770c6ba1 100644
--- a/drivers/bus/meson.build
+++ b/drivers/bus/meson.build
@@ -1,5 +1,12 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2017 Intel Corporation
 
-drivers = ['dpaa', 'fslmc', 'ifpga', 'pci', 'vdev', 'vmbus']
+drivers = [
+        'dpaa',
+        'fslmc',
+        'ifpga',
+        'pci',
+        'vdev',
+        'vmbus',
+]
 std_deps = ['eal']
diff --git a/drivers/common/meson.build b/drivers/common/meson.build
index 9fdfc2451..4acbad60b 100644
--- a/drivers/common/meson.build
+++ b/drivers/common/meson.build
@@ -2,4 +2,11 @@
 # Copyright(c) 2018 Cavium, Inc
 
 std_deps = ['eal']
-drivers = ['cpt', 'dpaax', 'iavf', 'mvep', 'octeontx', 'octeontx2']
+drivers = [
+        'cpt',
+        'dpaax',
+        'iavf',
+        'mvep',
+        'octeontx',
+        'octeontx2',
+]
diff --git a/drivers/compress/meson.build b/drivers/compress/meson.build
index 49fa02d4c..abe043ab9 100644
--- a/drivers/compress/meson.build
+++ b/drivers/compress/meson.build
@@ -2,9 +2,14 @@
 # Copyright(c) 2018 Intel Corporation
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['isal', 'mlx5', 'octeontx', 'zlib']
+drivers = [
+        'isal',
+        'mlx5',
+        'octeontx',
+        'zlib',
+]
 
 std_deps = ['compressdev'] # compressdev pulls in all other needed deps
diff --git a/drivers/crypto/meson.build b/drivers/crypto/meson.build
index c927c5f8d..b9fdf9392 100644
--- a/drivers/crypto/meson.build
+++ b/drivers/crypto/meson.build
@@ -2,27 +2,29 @@
 # Copyright(c) 2017 Intel Corporation
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['aesni_gcm',
-	   'aesni_mb',
-	   'armv8',
-	   'bcmfs',
-	   'caam_jr',
-	   'ccp',
-	   'dpaa_sec',
-	   'dpaa2_sec',
-	   'kasumi',
-	   'mvsam',
-	   'nitrox',
-	   'null',
-	   'octeontx',
-	   'octeontx2',
-	   'openssl',
-	   'scheduler',
-	   'snow3g',
-	   'virtio',
-	   'zuc']
+drivers = [
+        'aesni_gcm',
+        'aesni_mb',
+        'armv8',
+        'bcmfs',
+        'caam_jr',
+        'ccp',
+        'dpaa_sec',
+        'dpaa2_sec',
+        'kasumi',
+        'mvsam',
+        'nitrox',
+        'null',
+        'octeontx',
+        'octeontx2',
+        'openssl',
+        'scheduler',
+        'snow3g',
+        'virtio',
+        'zuc',
+]
 
 std_deps = ['cryptodev'] # cryptodev pulls in all other needed deps
diff --git a/drivers/event/meson.build b/drivers/event/meson.build
index b7f9bf7c6..539c5aeb9 100644
--- a/drivers/event/meson.build
+++ b/drivers/event/meson.build
@@ -2,13 +2,21 @@
 # Copyright(c) 2017 Intel Corporation
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['dlb2', 'dpaa', 'dpaa2', 'octeontx2', 'opdl', 'skeleton', 'sw',
-	   'dsw']
+drivers = [
+        'dlb2',
+        'dpaa',
+        'dpaa2',
+        'dsw',
+        'octeontx2',
+        'opdl',
+        'skeleton',
+        'sw',
+]
 if not (toolchain == 'gcc' and cc.version().version_compare('<4.8.6') and
-	dpdk_conf.has('RTE_ARCH_ARM64'))
-	drivers += 'octeontx'
+        dpdk_conf.has('RTE_ARCH_ARM64'))
+    drivers += 'octeontx'
 endif
 std_deps = ['eventdev', 'kvargs']
diff --git a/drivers/mempool/meson.build b/drivers/mempool/meson.build
index a2814c1df..caaffc380 100644
--- a/drivers/mempool/meson.build
+++ b/drivers/mempool/meson.build
@@ -1,6 +1,14 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2017 Intel Corporation
 
-drivers = ['bucket', 'cnxk', 'dpaa', 'dpaa2', 'octeontx', 'octeontx2', 'ring',
-	   'stack']
+drivers = [
+        'bucket',
+        'cnxk',
+        'dpaa',
+        'dpaa2',
+        'octeontx',
+        'octeontx2',
+        'ring',
+        'stack',
+]
 std_deps = ['mempool']
diff --git a/drivers/meson.build b/drivers/meson.build
index f90330b5a..b78cac389 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -3,26 +3,26 @@
 
 # Defines the order of dependencies evaluation
 subdirs = [
-	'common',
-	'bus',
-	'common/cnxk', # depends on bus.
-	'common/mlx5', # depends on bus.
-	'common/qat', # depends on bus.
-	'common/sfc_efx', # depends on bus.
-	'mempool', # depends on common and bus.
-	'net',     # depends on common, bus, mempool
-	'raw',     # depends on common, bus and net.
-	'crypto',  # depends on common, bus and mempool (net in future).
-	'compress', # depends on common, bus, mempool.
-	'regex', # depends on common, bus, regexdev.
-	'vdpa',    # depends on common, bus and mempool.
-	'event',   # depends on common, bus, mempool and net.
-	'baseband', # depends on common and bus.
+        'common',
+        'bus',
+        'common/cnxk',    # depends on bus.
+        'common/mlx5',    # depends on bus.
+        'common/qat',     # depends on bus.
+        'common/sfc_efx', # depends on bus.
+        'mempool',        # depends on common and bus.
+        'net',            # depends on common, bus, mempool
+        'raw',            # depends on common, bus and net.
+        'crypto',         # depends on common, bus and mempool (net in future).
+        'compress',       # depends on common, bus, mempool.
+        'regex',          # depends on common, bus, regexdev.
+        'vdpa',           # depends on common, bus and mempool.
+        'event',          # depends on common, bus, mempool and net.
+        'baseband',       # depends on common and bus.
 ]
 
 if meson.is_cross_build()
-	disable_drivers += ',' + meson.get_cross_property('disable_drivers', '')
-	enable_drivers += ',' + meson.get_cross_property('enable_drivers', '')
+    disable_drivers += ',' + meson.get_cross_property('disable_drivers', '')
+    enable_drivers += ',' + meson.get_cross_property('enable_drivers', '')
 endif
 
 # add cmdline disabled drivers and meson disabled drivers together
@@ -33,7 +33,7 @@ disable_drivers = run_command(list_dir_globs, disable_drivers).stdout().split()
 enable_drivers = ',' + get_option('enable_drivers')
 enable_drivers = run_command(list_dir_globs, enable_drivers).stdout().split()
 if enable_drivers.length() == 0
-	enable_drivers = run_command(list_dir_globs, '*/*').stdout().split()
+    enable_drivers = run_command(list_dir_globs, '*/*').stdout().split()
 endif
 
 # these drivers must always be enabled, otherwise the build breaks
@@ -45,7 +45,7 @@ default_cflags += ['-DALLOW_EXPERIMENTAL_API']
 default_cflags += ['-DALLOW_INTERNAL_API']
 
 if cc.has_argument('-Wno-format-truncation')
-	default_cflags += '-Wno-format-truncation'
+    default_cflags += '-Wno-format-truncation'
 endif
 
 foreach subpath:subdirs
diff --git a/drivers/net/meson.build b/drivers/net/meson.build
index fb9ff05a1..c8b5ce298 100644
--- a/drivers/net/meson.build
+++ b/drivers/net/meson.build
@@ -2,58 +2,62 @@
 # Copyright(c) 2017 Intel Corporation
 
 
-drivers = ['af_packet',
-	'af_xdp',
-	'ark',
-	'atlantic',
-	'avp',
-	'axgbe', 'bonding',
-	'bnx2x',
-	'bnxt',
-	'cxgbe',
-	'dpaa', 'dpaa2',
-	'e1000',
-	'ena',
-	'enetc',
-	'enic',
-	'failsafe',
-	'fm10k', 'i40e',
-	'hinic',
-	'hns3',
-	'iavf',
-	'ice',
-	'igc',
-	'ionic',
-	'ipn3ke',
-	'ixgbe',
-	'kni',
-	'liquidio',
-	'memif',
-	'mlx4',
-	'mlx5',
-	'mvneta',
-	'mvpp2',
-	'netvsc',
-	'nfb',
-	'nfp',
-	'null',
-	'octeontx',
-	'octeontx2',
-	'octeontx_ep',
-	'pcap',
-	'pfe',
-	'qede',
-	'ring',
-	'sfc',
-	'softnic',
-	'szedata2',
-	'tap',
-	'thunderx',
-	'txgbe',
-	'vdev_netvsc',
-	'vhost',
-	'virtio',
-	'vmxnet3',
+drivers = [
+        'af_packet',
+        'af_xdp',
+        'ark',
+        'atlantic',
+        'avp',
+        'axgbe',
+        'bnx2x',
+        'bnxt',
+        'bonding',
+        'cxgbe',
+        'dpaa',
+        'dpaa2',
+        'e1000',
+        'ena',
+        'enetc',
+        'enic',
+        'failsafe',
+        'fm10k',
+        'hinic',
+        'hns3',
+        'i40e',
+        'iavf',
+        'ice',
+        'igc',
+        'ionic',
+        'ipn3ke',
+        'ixgbe',
+        'kni',
+        'liquidio',
+        'memif',
+        'mlx4',
+        'mlx5',
+        'mvneta',
+        'mvpp2',
+        'netvsc',
+        'nfb',
+        'nfp',
+        'null',
+        'octeontx',
+        'octeontx2',
+        'octeontx_ep',
+        'pcap',
+        'pfe',
+        'qede',
+        'ring',
+        'sfc',
+        'softnic',
+        'szedata2',
+        'tap',
+        'thunderx',
+        'txgbe',
+        'vdev_netvsc',
+        'vhost',
+        'virtio',
+        'vmxnet3',
 ]
 std_deps = ['ethdev', 'kvargs'] # 'ethdev' also pulls in mbuf, net, eal etc
 std_deps += ['bus_pci']         # very many PMDs depend on PCI, so make std
diff --git a/drivers/raw/meson.build b/drivers/raw/meson.build
index 8c3a036df..c33a7c5f3 100644
--- a/drivers/raw/meson.build
+++ b/drivers/raw/meson.build
@@ -2,12 +2,17 @@
 # Copyright 2018 NXP
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['dpaa2_cmdif', 'dpaa2_qdma',
-	'ifpga', 'ioat', 'ntb',
-	'octeontx2_dma',
-	'octeontx2_ep',
-	'skeleton']
+drivers = [
+        'dpaa2_cmdif',
+        'dpaa2_qdma',
+        'ifpga',
+        'ioat',
+        'ntb',
+        'octeontx2_dma',
+        'octeontx2_ep',
+        'skeleton',
+]
 std_deps = ['rawdev']
diff --git a/drivers/regex/meson.build b/drivers/regex/meson.build
index 2d05d5af1..94222e55f 100644
--- a/drivers/regex/meson.build
+++ b/drivers/regex/meson.build
@@ -1,5 +1,8 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2020 Mellanox Technologies, Ltd
 
-drivers = ['mlx5', 'octeontx2']
+drivers = [
+        'mlx5',
+        'octeontx2',
+]
 std_deps = ['ethdev', 'kvargs'] # 'ethdev' also pulls in mbuf, net, eal etc
diff --git a/drivers/vdpa/meson.build b/drivers/vdpa/meson.build
index 4929be4c0..f765fe398 100644
--- a/drivers/vdpa/meson.build
+++ b/drivers/vdpa/meson.build
@@ -2,10 +2,12 @@
 # Copyright 2019 Mellanox Technologies, Ltd
 
 if is_windows
-	subdir_done()
+    subdir_done()
 endif
 
-drivers = ['ifc',
-	   'mlx5',]
+drivers = [
+        'ifc',
+        'mlx5',
+]
 std_deps = ['bus_pci', 'kvargs']
 std_deps += ['vhost']